/*
	Copyright 2016, 2017 Michele "King_DuckZ" Santullo

	This file is part of MyCurry.

	MyCurry is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	MyCurry is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with MyCurry.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "tileindextype.hpp"
#include "tileproperty.hpp"
#include <string>
#include <vector>
#include <cstdint>

namespace curry {
	struct CSVJointData {
		CSVJointData() = default;
		CSVJointData (CSVJointData&&) = default;
		CSVJointData (const CSVJointData&) = delete;

		std::vector<std::vector<TileIndex>> tables;
		std::vector<TileProperty> tile_properties; //not filled in with real values
		uint16_t width;
		uint16_t height;
	};

	CSVJointData load_csv(const std::vector<std::string>& parCsvPath);
} //namespace curry
