/*
	Copyright 2016, 2017 Michele "King_DuckZ" Santullo

	This file is part of MyCurry.

	MyCurry is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	MyCurry is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with MyCurry.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "vector.hpp"
#include "mycurry_toplevelConfig.h"
#include <functional>

namespace curry {
	class WorldGrid;

#if defined(BUILD_TESTING)
	float segment_intersection (const vec2f& parA, const vec2f& parDirA, const vec2f& parB, const vec2f& parDirB);
#endif

	void for_each_cell_under_segment (
		const vec2f& parFrom,
		const vec2f& parTo,
		vec2us parObjSize,
		const WorldGrid& parWorld,
		std::function<bool(vec2us)> parFunc,
		bool parInclFirst
	);
} //namespace curry
