/*
	Copyright 2016, 2017 Michele "King_DuckZ" Santullo

	This file is part of MyCurry.

	MyCurry is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	MyCurry is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with MyCurry.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "gamescenebase.hpp"
#include "safe_ptr.hh"
#include "draw_layer_names.hpp"
#include <memory>
#include <cstddef>

namespace cloonel {
	class SDLMain;
} //namespace cloonel

namespace curry {
	class Texture;

	class IngameScene : public GameSceneBase {
	public:
		explicit IngameScene (cloonel::SDLMain* parSDLMain);
		virtual ~IngameScene() noexcept;

	protected:
		virtual void on_prepare() override;
		virtual void on_destroy() noexcept override;
		virtual void on_update (float parDeltaT) override;
		void draw (DrawaLayerNames parLayer, Kakoune::SafePtr<Texture>& parTexture, Rect<float> parSrc, Rect<float> parDest);

	private:
		struct LocalData;

		std::unique_ptr<LocalData> m_local_data;
	};
} //namespace curry
