/*
	Copyright 2016, 2017 Michele "King_DuckZ" Santullo

	This file is part of MyCurry.

	MyCurry is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	MyCurry is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with MyCurry.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "rect.hpp"
#include "compatibility.h"
#include <SDL2/SDL.h>
#include <utility>

namespace curry {
	template <typename T>
	inline SDL_Rect make_sdlrect (const Rect<T>& parOther) {
		typedef decltype(std::declval<SDL_Rect>().w) ValueType;

		return SDL_Rect{
			static_cast<ValueType>(parOther.left()),
			static_cast<ValueType>(parOther.top()),
			static_cast<ValueType>(parOther.width()),
			static_cast<ValueType>(parOther.height())
		};
	}

	SDL_Rect make_sdlrect (const Rect<float>& parOther) a_pure;
} //namespace curry
