/*
	Copyright 2016-2018 Michele "King_DuckZ" Santullo

	This file is part of MyCurry.

	MyCurry is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	MyCurry is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with MyCurry.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "moveable.hpp"
#include "worldsizenotifiable.hpp"
#include "constrained_position.hpp"

namespace curry {
	class WorldGrid;

	class WorldMoveable : public Moveable, public WorldSizeNotifiable {
	public:
		explicit WorldMoveable (const WorldSizeNotifiable::DeferredRegister& parDeferredRegister);
		virtual ~WorldMoveable() = default;

		virtual void world_size_changed (const vec2us& parSize, const vec2i& parPixelSize) override;
		const vec2f& position() const;
		void set_position (const vec2f& parPos);
		WorldGrid& world();
		const WorldGrid& world() const;

	protected:
		void update_moveable_size (const vec2f& parOldSz, const vec2f& parNewSz);

	private:
		ConstrainedPosition<vec2f> m_position;
		WorldGrid* m_world;
	};
} //namespace curry
