/*
	Copyright 2016, 2017 Michele "King_DuckZ" Santullo

	This file is part of MyCurry.

	MyCurry is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	MyCurry is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with MyCurry.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "worlditems.hpp"
#include "moveable.hpp"

namespace curry {
	WorldItems::WorldItems() = default;

	void WorldItems::register_observer (Moveable* parMoveable) {
		m_moveables.Add(parMoveable);
	}

	void WorldItems::unregister_all() noexcept {
		m_moveables.RemoveAll();
	}

	void WorldItems::move_items (float parDeltaT) {
		for (auto& m : m_moveables) {
			m->do_movement(parDeltaT);
		}
	}

	bool WorldItems::no_items_registered() const {
		return static_cast<bool>(not m_moveables.size());
	}
} //namespace curry
