/*
	Copyright 2016, 2017 Michele "King_DuckZ" Santullo

	This file is part of MyCurry.

	MyCurry is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	MyCurry is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with MyCurry.  If not, see <http://www.gnu.org/licenses/>.
*/

#pragma once

#include "observersmanager.hpp"

namespace curry {
	class Moveable;

	class WorldItems {
		//typedef cloonel::ObserversManager<Moveable*>::TicketType MoveableTicketType;

	public:
		WorldItems();
		~WorldItems() noexcept = default;

		void register_observer (Moveable* parMoveable);
		void unregister_all() noexcept;
		void move_items (float parDeltaT);
		bool no_items_registered() const;

	private:
		cloonel::ObserversManager<Moveable*> m_moveables;
	};
} //namespace curry
